pExplosion = GetIntParam("explosion",3)

function init()
	--initialise and fine all objecst
    plungertrigger = FindShape("plungertrigger")
	soundshape = FindShape("soundsource")
	charges = FindBodies("remote_explosive")
	detonateSound = LoadSound("/snd/bombbutton.ogg")
	activatesound = LoadSound("/snd/beep1.ogg")
	deactivatesound = LoadSound("/snd/beep2.ogg")
	detonatetrigger = FindTrigger("detonate")
	motor = FindJoint("motorplunge")
	detonatorlight = FindLight("detonatorlight")
	bomblights = FindLights("bomblight")
	SetJointMotor(motor, -1.4, 5)
	checktrigger = true	
	detonated = false
	triggershape = FindShape("triggerlocation")
	triggerlocation = GetShapeWorldTransform(triggershape)
	triggerLocalT = TransformToLocalTransform(triggerlocation , GetTriggerTransform(detonatetrigger))
	--find all objects
	for i =1, #charges do
		SetLightEnabled(bomblights[i], false)
		SetTag(charges[i], "interact", "activate")
		SetTag(charges[i], "deactivated")
	end
	--set all lights to disabled
	
	checkplunger = false
	--prevents plunger detonating before its been removed from box
end

function tick(dt)
	
	plungerlocation = GetJointMovement(motor)
	--DebugWatch("joint extension", plungerlocation)
	if plungerlocation >0.2 and checkplunger == false then
		checkplunger = true
	end
	--^this prevents the plunger from detonating if it hasnt been taken out of the box yet

	SetLightEnabled(detonatorlight, false)
	bt = GetShapeWorldTransform(soundshape)
	triggerlocation = GetShapeWorldTransform(triggershape)
	SetTriggerTransform(detonatetrigger, TransformToParentTransform(triggerlocation , triggerLocalT))
	currentshape = GetPlayerInteractBody()
	check1 = true
	--^this ensures the trigger that activates the explosives follows the plunger body
	for i =1, #charges do
		if HasTag(charges[i], "deactivated") then
			SetLightEnabled(bomblights[i], false)
		end
	end
	--^disable all lights on the c4 by defualt
	
	
	for i =1, #charges do
		if currentshape == charges[i] and InputPressed("interact") then
				--DebugPrint("working")
			if  HasTag(charges[i], "deactivated") then
				--DebugPrint("workingactivate")
				RemoveTag(charges[i], "interact", "activate")
				RemoveTag(charges[i], "deactivated")
				SetTag(charges[i],"interact", "deactivate")
				SetTag(charges[i], "activated")
				PlaySound(activatesound)
				SetLightEnabled(bomblights[i], true)
				check1 = false
				pos = GetBodyTransform(charges[i]).pos
				--DebugWatch("pos", pos)
				Spawn("MOD/joint.xml", Transform(pos), true, true)
				--Spawn("MOD/spawncheck.xml", Transform(position), true, true)
				--Spawn("<voxbox size='10 10 10' prop='true' material='wood'/>", Transform(pos),true, true)
			end
			if  HasTag(charges[i], "activated") and check1 == true then
				--DebugPrint("workingdeactivate")
				RemoveTag(charges[i], "interact", "deactivate")
				RemoveTag(charges[i], "activated")
				SetTag(charges[i],"interact", "activate")
				SetTag(charges[i], "deactivated")
				PlaySound(deactivatesound)
				SetLightEnabled(bomblights[i], false)
				bodyshapes = GetBodyShapes(charges[i])
				for i=1, #bodyshapes do
					bombjoints = GetShapeJoints(bodyshapes[i])
					for i=1, #bombjoints do
						Delete(bombjoints[i])
					end
				end
				

			end
		end
	end
	--^ this checks user input on a charge. if it is deactivate then it will activate, turn on light, and create a joint to stick. when deactivating
	--it deletes the joint and turns off the light
	
	activatedcharges = FindBodies("activated")
	if #activatedcharges > 0 then
		SetLightEnabled(detonatorlight, true)
	end 
	if #activatedcharges == 0 then
		SetLightEnabled(detonatorlight, false)
	end
	--turns on the light on the detonator if at least one charge is active
	
	if IsShapeInTrigger(detonatetrigger, plungertrigger) and checktrigger == true and #activatedcharges > 0 and checkplunger == true then
        detonated = true
		detonatetime = GetTime()
		PlaySound(detonateSound, bt.pos)
		--SetJointMotor(motor, -1.4, 3)
		checktrigger = false
		--ensures the sound only plays once
	end
	--check if the plunger has been pushed down
	timenow = GetTime()
	if detonated == true and timenow > detonatetime+0.7 then
		if #activatedcharges > 0 then
			dbt = GetBodyTransform(activatedcharges[1])
            Explosion(dbt.pos, pExplosion)
			Delete(activatedcharges[1])
			table.remove(activatedcharges, 1)
			else 
			detonated = false
		end
	end
	--detonates all active explosives and deletes their body
	if #activatedcharges == 0 then
		checktrigger = true	
	--resets the detonator so it can be used multiple times
	end
end