pExplosion = GetIntParam("explosion",2)

function init()
	--this sets up the bomb and all relevant scripts
    plungertrigger = FindShape("plungertrigger")
	soundshape = FindShape("soundsource")
	detonateSound = LoadSound("/snd/bombbutton.ogg")
	activatesound = LoadSound("/snd/beep1.ogg")
	deactivatesound = LoadSound("/snd/beep2.ogg")
	leversound = LoadSound("/snd/lever.ogg")
	detonatetrigger = FindTrigger("detonate")
	charges = FindBodies("remote_explosive")
	motor = FindJoint("motorplunge")
	detonatorlight = FindLight("detonatorlight")
	bomblights = FindLights("bomblight")
	SetJointMotor(motor, -1.4, 5)
	checktrigger = true	
	detonated = false
	triggershape = FindShape("triggerlocation")
	triggerlocation = GetShapeWorldTransform(triggershape)
	triggerLocalT = TransformToLocalTransform(triggerlocation , GetTriggerTransform(detonatetrigger))
	for i =1, #charges do
		SetLightEnabled(bomblights[i], false)
		SetTag(charges[i], "interact", "activate")
		SetTag(charges[i], "deactivated")
	end
	checkplunger = false
	startinglights = #charges
	
	
	--DISPENSER 
	
	spawnshape = FindBody("spawnbody")
	spawnshape2 = FindShape("spawnshape")
	lever = FindJoint("lever")
	spawnlocation = GetBodyTransform(spawnshape).pos
	spawnlocation2 = GetShapeLocalTransform(spawnshape2).pos
	SetJointMotor(lever, 3, 8)
	checklever = true
	--DebugWatch("spawn", spawnlocation2)
	
	

end

function tick(dt)
	charges = FindBodies("remote_explosive")
	bomblights = FindLights("bomblight")
	for i =1, #charges do
		if HasTag(charges[i], "spawned") then
		SetLightEnabled(bomblights[i], false)
		SetTag(charges[i], "interact", "activate")
		SetTag(charges[i], "deactivated")
		RemoveTag(charges[i], "spawned")
		end
	end
	--dispenser code
	leverrotate = GetJointMovement(lever)
	--DebugWatch("lever rotate", leverrotate)
	if leverrotate >80 and checklever == true then
		--DebugPrint("working")
		Spawn("MOD/spawnedc4.xml", Transform(spawnlocation), true, true)
		checklever = false
		PlaySound(leversound)
	end
	if leverrotate <10 and checklever == false then
		checklever = true
	end
	
	--ENSURES PLUNGER ONLY ACTIVATES ONCE WHEN PULLED
	plungerlocation = GetJointMovement(motor)
	--DebugWatch("joint extension", plungerlocation)
	if plungerlocation >0.2 and checkplunger == false then
		checkplunger = true
	end
	--TURNS ALL LIGHTS OFF AT THE START
	SetLightEnabled(detonatorlight, false)
	bt = GetShapeWorldTransform(soundshape)
	triggerlocation = GetShapeWorldTransform(triggershape)
	SetTriggerTransform(detonatetrigger, TransformToParentTransform(triggerlocation , triggerLocalT))
	currentshape = GetPlayerInteractBody()
	check1 = true
	for i =1, #charges do
		if HasTag(charges[i], "deactivated") then
			SetLightEnabled(bomblights[i], false)
		end
	end

		--TOGGLE ACTIVATED OR DEACTIVATED ON EACH CHARGE WHEN PRESSED
	for i =1, #charges do
		if currentshape == charges[i] and InputPressed("interact") then
				--DebugPrint("working")
			if  HasTag(charges[i], "deactivated") then
				--DebugPrint("workingactivate")
				RemoveTag(charges[i], "interact", "activate")
				RemoveTag(charges[i], "deactivated")
				SetTag(charges[i],"interact", "deactivate")
				SetTag(charges[i], "activated")
				PlaySound(activatesound)
				SetLightEnabled(bomblights[i], true)
				check1 = false
				pos = GetBodyTransform(charges[i]).pos
				--DebugWatch("pos", pos)
				Spawn("MOD/joint.xml", Transform(pos), true, true)
				--Spawn("MOD/spawncheck.xml", Transform(position), true, true)
				--Spawn("<voxbox size='10 10 10' prop='true' material='wood'/>", Transform(pos),true, true)
			end
			if  HasTag(charges[i], "activated") and check1 == true then
				--DebugPrint("workingdeactivate")
				RemoveTag(charges[i], "interact", "deactivate")
				RemoveTag(charges[i], "activated")
				SetTag(charges[i],"interact", "activate")
				SetTag(charges[i], "deactivated")
				PlaySound(deactivatesound)
				SetLightEnabled(bomblights[i], false)
				bodyshapes = GetBodyShapes(charges[i])
				for i=1, #bodyshapes do
					bombjoints = GetShapeJoints(bodyshapes[i])
					for i=1, #bombjoints do
						Delete(bombjoints[i])
					end
				end
				

			end
		end
	end
	
	--SWITCHES ON THE DETONATOR LIGHT WHEN 1 OR MORE CHARGE IS ACTIVATED
	activatedcharges = FindBodies("activated")
	if #activatedcharges > 0 then
		SetLightEnabled(detonatorlight, true)
	end 
	if #activatedcharges == 0 then
		SetLightEnabled(detonatorlight, false)
	end
		
		--CHECK IF PLUNGER IS PULLED ALL THE WAY, IF IT IS SET DONATED TO TRUE
	if IsShapeInTrigger(detonatetrigger, plungertrigger) and checktrigger == true and #activatedcharges > 0 and checkplunger == true then
        detonated = true
		detonatetime = GetTime()
		PlaySound(detonateSound, bt.pos)
		--SetJointMotor(motor, -1.4, 3)
		checktrigger = false
	end
	--DETONATE THE CHARGES AFTER A SHORT DELAY
	timenow = GetTime()
	if detonated == true and timenow > detonatetime+0.7 then
		if #activatedcharges > 0 then
			dbt = GetBodyTransform(activatedcharges[1])
            Explosion(dbt.pos, pExplosion)
			Delete(activatedcharges[1])
			table.remove(activatedcharges, 1)
			else 
			detonated = false
		end
	end
	if #activatedcharges == 0 then
		checktrigger = true	
	end
end